package cn.iocoder.yudao.module.supplier.service.product;

import javax.validation.*;
import cn.iocoder.yudao.module.supplier.controller.admin.product.vo.SupplierPageReqVO;
import cn.iocoder.yudao.module.supplier.controller.admin.product.vo.SupplierRespVO;
import cn.iocoder.yudao.module.supplier.controller.admin.product.vo.SupplierSaveReqVO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.supplier.dal.dataobject.product.SupplierDO;

import java.util.List;

/**
 * 供应商主数据 Service 接口
 *
 * @author 芋道源码
 */
public interface SupplierService {

    /**
     * 创建供应商主数据
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long create(@Valid SupplierSaveReqVO createReqVO);

    /**
     * 更新供应商主数据
     *
     * @param updateReqVO 更新信息
     */
    void update(@Valid SupplierSaveReqVO updateReqVO);

    /**
     * 删除供应商主数据
     *
     * @param id 编号
     */
    void delete(Long id);

    /**
     * 获得供应商主数据
     *
     * @param id 编号
     * @return 供应商主数据
     */
    SupplierDO get(Long id);

    /**
     * 获得供应商主数据分页
     *
     * @param pageReqVO 分页查询
     * @return 供应商主数据分页
     */
    PageResult<SupplierDO> getPage(SupplierPageReqVO pageReqVO);

    List<SupplierDO> getAll();
    void changeStatus(Long id, Integer status);

    /**
     * 提交供应商数据审核
     *
     */
    Long submitForApproval(Long id);

    /**
     * 更新供应商审批结果
     *
     * @param id        供应商编号
     * @param bpmResult BPM 审批结果
     */
    void updateSupplierAuditStatus(Long id, Integer bpmResult);

    /**
     * 供应商基本信息及所有子表信息
     *
     * @param id        供应商编号
     */
    SupplierRespVO allSupplierInfo(Long id);

    /**
     * 根据流程实例id查询供应商信息
     *
     * @param bpmProcessInstanceId        流程实例id
     */
    SupplierDO getByBpmProcessId(String bpmProcessInstanceId);
}
